package com.brackeen.evolution.core;

import playn.core.Connection;
import playn.core.Layer;
import playn.core.Mouse;
import playn.core.Pointer;

public class Actor {

    private Scene scene;
    private Connection connection;
    private Layer.HasSize layer;
    private boolean shouldRemove;

    public boolean shouldRemove() {
        return shouldRemove;
    }

    public void setShouldRemove(boolean shouldRemove) {
        this.shouldRemove = shouldRemove;
    }

    public Scene getScene() {
        return scene;
    }

    public void setScene(Scene scene) {
        this.scene = scene;
    }

    public Layer.HasSize layer() {
        return layer;
    }

    public void setLayer(Layer.HasSize layer) {
        this.layer = layer;
    }
    
    public void setPointerListener(Pointer.Listener listener) {
        if (connection != null) {
            connection.disconnect();
            connection = null;
        }
        if (listener != null && layer != null) {
            connection = layer.addListener(listener);
        }
    }
    
    public void setMouseListener(Mouse.LayerListener listener) {
        if (connection != null) {
            connection.disconnect();
            connection = null;
        }
        if (listener != null && layer != null) {
            connection = layer.addListener(listener);
        }
    }
        
    public void update(Evolution evolution, float delta) {

    }
    
    public void notifyRemoved() {
        setPointerListener(null);
        setMouseListener(null);
    }
}
