package com.brackeen.evolution.core;

import com.brackeen.evolution.core.game.Star;
import com.brackeen.evolution.core.util.MathUtil;
import playn.core.Color;
import playn.core.ImmediateLayer;
import playn.core.Layer;
import playn.core.PlayN;
import playn.core.Surface;

public class StarsBackgroundScene extends Scene {

    public StarsBackgroundScene(Evolution evolution) {
        
        // Just a black background. Is this needed?
        Layer bgLayer = PlayN.graphics().createImmediateLayer(evolution.getScreenWidth(), evolution.getScreenHeight(), new ImmediateLayer.Renderer() {

            @Override
            public void render(Surface surface) {
                surface.setFillColor(Color.rgb(0, 0, 0));
                surface.fillRect(0, 0, surface.width(), surface.height());
            }
        });
        rootLayer().add(bgLayer);
        
        // A bunch of random stars
        for (int i = 0; i < 128; i++) {
            float x = MathUtil.random(Evolution.WIDTH) * Evolution.SCALE;
            float y = MathUtil.random(Evolution.HEIGHT) * Evolution.SCALE;
            float depth = MathUtil.random(0.0f, 1.0f);
            float frequency = MathUtil.random(1.0f, 2.0f);
            int color = Evolution.COLORS[MathUtil.random(1, 8)]; // exclude black
            addActor(new Star(x, y, color, depth, frequency));
        }
    }
}
