package com.brackeen.evolution.core.game;

import com.brackeen.evolution.core.Evolution;
import playn.core.Canvas;
import playn.core.CanvasImage;
import playn.core.Image;
import playn.core.PlayN;

public class SpriteCreator {
    
    public static final int WIDTH = 8;
    public static final int HEIGHT = 16;
    
    public static Image create(int[][] grid) {
        int scale = Evolution.SCALE;
        CanvasImage canvasImage = PlayN.graphics().createImage(WIDTH * 2 * scale, HEIGHT * scale);
        Canvas canvas = canvasImage.canvas();
        canvas.clear();
        for (int y = 0; y < HEIGHT; y++) {
            for (int x = 0; x < WIDTH; x++) {
                int colorIndex = grid[y][x];
                if (colorIndex != 0) {
                    int color = Evolution.COLORS[colorIndex];
                    canvas.setFillColor(color);
                    canvas.fillRect(x * scale, y * scale, scale, scale);
                    if (x < WIDTH - 1) {
                        canvas.fillRect((WIDTH*2 - x - 2) * scale, y * scale, scale, scale);
                    }
                }
            }
        }
        return canvasImage;
    }

    private SpriteCreator() {
    }

}
