package com.brackeen.evolution.core.util;

import java.util.Collection;
import java.util.List;

public class MathUtil {
    
    public static <T> T random(Collection<T> collection) {
        if (collection.isEmpty()) {
            return null;
        }
        int index = random(collection.size());
        if (collection instanceof List) {
            return ((List<T>)collection).get(index);
        }
        else {
            int i = 0;
            for (T t : collection) {
                if (i == index) {
                    return t;
                }
                i++;
            }
            // Shouldn't happen
            return null;
        }
    }
    
    public static int clamp(int n, int min, int max) {
        if (n <= min) {
            return min;
        }
        else if (n >= max) {
            return max;
        }
        else {
            return n;
        }
    }
    
     public static float clamp(float n, float min, float max) {
        if (n <= min) {
            return min;
        }
        else if (n >= max) {
            return max;
        }
        else {
            return n;
        }
    }
    
    public static int log2(int n) {
        int count = 0;
        while (true) {
            n >>= 1;
            if (n == 0) {
                return count;
            }
            count++;
        }
    }
    
    public static float distSq(float x1, float y1, float x2, float y2) {
        float dx = x1 - x2;
        float dy = y1 - y2;
        return dx * dx + dy *dy;
    }
    
    public static float dist(float x1, float y1, float x2, float y2) {
        return (float)Math.sqrt(distSq(x1, y1, x2, y2));
    }
    
    public static boolean probability(double p) {
        return Math.random() < p;
    }

    public static int random(int maxExclusive) {
        return random(0, maxExclusive);
    }
    
    public static int random(int min, int maxExclusive) {
        int len = maxExclusive - min;
        return min + (int)(Math.random() * len);
    }
    
    public static float random(float min, float maxExclusive) {
        float len = maxExclusive - min;
        return min + (float)Math.random() * len;
    }

    private MathUtil() {
    }
}
